import { Hono } from "hono/tiny";
import { createRoute } from "../../modules/api-utils/createRoute";
import { credentials } from "../../managers/credentials";
import { apiResponse } from "../../modules/api-utils/apiResponse";
import { ContentfulStatusCode } from "hono/utils/http-status";
import { authMiddleware } from "../middleware/authorization";

/* /v1/credential/:id/fields */
export default createRoute(
  "get",
  ["/credentials/:id/fields"],

  async (c) => {
    const credential = await credentials.fetch(c.req.param("id"));
    const fields = await credential.fetchAllFieldValues();

    const response = apiResponse.successful(
      "Credential Fields Fetched Successfully!",
      fields,
    );
    return c.json(response, response.status as ContentfulStatusCode);
  },
  authMiddleware({
    permissions: ["credential.fetch", "credential.fields.fetch"],
  }),
);
